Macro Coque [RÉSOLU]

vos questions concernant les API SolidWorks

Macro Coque [RÉSOLU]

Messagepar jibe » Lun 17 Mar 2014, 10:22

Bonjour,

j'ai créé une macro Coque pour qu'elle se fasse en auto de la face supérieur de ma pièce mais il y a un décalage et la fonction Coque s’effectue à l'intérieur de la pièce...

Voici mon code

Code: Tout sélectionner
Sub Coque()
Dim epaisseur As Double

epaisseur = InputBox("Quelle épaisseur de verre voulez-vous? (en mm)") / 1000

Set swApp = _
Application.SldWorks

Set Part = swApp.ActiveDoc
Part.ViewZoomtofit2
boolstatus = Part.Extension.SelectByID2("", "FACE", Range("D" & nb_lignes), Range("D" & nb_lignes + 1), 0, True, 0, Nothing, 0)
Part.ClearSelection2 True
boolstatus = Part.Extension.SelectByID2("", "FACE", Range("D" & nb_lignes), Range("D" & nb_lignes + 1), 0, False, 1, Nothing, 0)
Part.InsertFeatureShell epaisseur, False

End Sub


Range("D" & nb_lignes) et Range("D" & nb_lignes+1) sont les coordonnées des dernières points créés, soit ceux de la face supérieur de l'esquisse.

Merci pour votre aide,

JB
Dernière édition par jibe le Mar 18 Mar 2014, 12:01, édité 2 fois.
jibe
Ewok SolidWorks
 
Messages: 5
Inscription: Lun 17 Mar 2014, 10:12

Re: Macro Coque

Messagepar Solaris » Lun 17 Mar 2014, 12:07

j'y connais pas grand chose en API,

mais visiblement il te manque juste la traduction en langage API, de la petite option de la fonction coque "vers l’extérieur"

en espérant que ça puisse t'aider...
Avatar de l’utilisateur
Solaris
Padawan SolidWorks
 
Messages: 177
Inscription: Ven 07 Juin 2013, 9:30

Re: Macro Coque

Messagepar jibe » Lun 17 Mar 2014, 12:30

l'Option "Coque vers l'extérieur", crée de la matière autour de la pièce et fait le vide à l'intérieur.

Moi ce que je recherche c'est juste de vider la pièce sans en modifier les côtes extérieurs.
jibe
Ewok SolidWorks
 
Messages: 5
Inscription: Lun 17 Mar 2014, 10:12

Re: Macro Coque

Messagepar liryc » Lun 17 Mar 2014, 13:27

Avec l'enregistrement de macro j'obtiens ça:
Code: Tout sélectionner
boolstatus = Part.Extension.SelectByID2("", "FACE", 0.01137166713353, 0.01911551117256, 0, False, 0, Nothing, 0)
Part.ClearSelection2 True
boolstatus = Part.Extension.SelectByID2("", "FACE", 0.01137166713353, 0.01911551117256, 0, False, 1, Nothing, 0)
Part.InsertFeatureShell 0.005, False

Deux fois False dans les selection et pas True.
Sinon, si ça ne sélectionne pas la bonne face (ce que j'ai cru comprendre) il faut vérifier le repère.
Tel que définit dans ta macro c'est X, Y.
liryc
Chevalier Jedi SolidWorks
 
Messages: 479
Inscription: Ven 02 Mar 2007, 8:14
Localisation: Paris - SW2009 SP5.0

Re: Macro Coque

Messagepar jibe » Lun 17 Mar 2014, 17:46

Liryc, il n'y a pas de différence lorsque je change le true en false

Sinon, si ça ne sélectionne pas la bonne face (ce que j'ai cru comprendre) il faut vérifier le repère.
Tel que définit dans ta macro c'est X, Y.


tu veux dire quoi par vérifier le repère?
jibe
Ewok SolidWorks
 
Messages: 5
Inscription: Lun 17 Mar 2014, 10:12

Re: Macro Coque

Messagepar liryc » Mar 18 Mar 2014, 9:10

L'orientation de la piéce.
Mais bon je ne comprends pas totalement ton problème et ta notion de décalage.
Une image aiderait je pense.
liryc
Chevalier Jedi SolidWorks
 
Messages: 479
Inscription: Ven 02 Mar 2007, 8:14
Localisation: Paris - SW2009 SP5.0

Re: Macro Coque

Messagepar jibe » Mar 18 Mar 2014, 9:48

Voici l'image de ma fonction.

On voit que la Coque ne se fait que à l'intérieur de la pièce.

J'ai fait un autre test: j'ai crée un point sur la face souhaité et je l'ai sélectionné pour la fonction coque.
même résultat, la fonction n'est pas débouchante
Coque.jpg
Coque.jpg (75.84 Kio) Vu 1008 fois
.
jibe
Ewok SolidWorks
 
Messages: 5
Inscription: Lun 17 Mar 2014, 10:12

Re: Macro Coque

Messagepar liryc » Mar 18 Mar 2014, 10:21

C'est bizarre, tu as le comportement d'une coque sans sélection de face.
Quand tu le fais manuellement est-ce que la face sélectionnée apparaît bien dans l'interface?
Si ce n'est pas le cas, fait appel à ta hotline car sûrement un bug ou le modèle qui pose problème.
liryc
Chevalier Jedi SolidWorks
 
Messages: 479
Inscription: Ven 02 Mar 2007, 8:14
Localisation: Paris - SW2009 SP5.0

Re: Macro Coque

Messagepar gt22 » Mar 18 Mar 2014, 10:25

jibe a écrit:Voici l'image de ma fonction.

On voit que la Coque ne se fait que à l'intérieur de la pièce.

J'ai fait un autre test: j'ai crée un point sur la face souhaité et je l'ai sélectionné pour la fonction coque.
même résultat, la fonction n'est pas débouchante
Coque.jpg
.


peut être que par défaut il prends coque interieur
2 options
savoir gérer les options de base fonction coque inter ou exter (macro, paramétrage fonction coque)
créer son profil en extérieur donc peau comprise
@+ :wink:
Avatar de l’utilisateur
gt22
Padawan SolidWorks
 
Messages: 198
Inscription: Ven 10 Juin 2011, 19:29

Re: Macro Coque

Messagepar gt22 » Mar 18 Mar 2014, 10:31

gt22 a écrit:
jibe a écrit:Voici l'image de ma fonction.

On voit que la Coque ne se fait que à l'intérieur de la pièce.

J'ai fait un autre test: j'ai crée un point sur la face souhaité et je l'ai sélectionné pour la fonction coque.
même résultat, la fonction n'est pas débouchante
Coque.jpg
.


peut être que par défaut il prends coque interieur (macro????)

3 options
_savoir gérer les options de base fonction coque inter ou exter (macro, paramétrage fonction coque)
_créer son profil en extérieur donc peau comprise
_laisser faire l’épaisseur inter et retourner sur la fonction coque inverser le sens

@+ :wink:
Avatar de l’utilisateur
gt22
Padawan SolidWorks
 
Messages: 198
Inscription: Ven 10 Juin 2011, 19:29

Re: Macro Coque

Messagepar LHPM Concept » Mar 18 Mar 2014, 10:32

A priori ta macro sélectionne ton corps et non ta face.
lance ta macro en pas a pas et vois comment réagi ta pièce à la fonction selectbyID2.
Il faut bien que tu rentre les coordonnées d'un seul point dans ta fonction en x,y et z
tes coordonnées en mètre, et ton point ne doit pas être un sommet adjacent à plusieurs faces.
exemple:

Sub main()

Set swApp = _
Application.SldWorks

Set Part = swApp.ActiveDoc


boolstatus = Part.Extension.SelectByID2("", "FACE", X, Y, Z, False, 1, Nothing, 0)
Part.InsertFeatureShell 0.005, False
End Sub
LHPM Concept
Ewok SolidWorks
 
Messages: 21
Inscription: Mer 12 Mar 2014, 10:31
Localisation: 36 - Indre

Re: Macro Coque

Messagepar jibe » Mar 18 Mar 2014, 11:55

Ou c'est le talent ou c'est le désespoir. :P

J'ai changé le Part.ViewZoomtofit2 en Part.ShowNamedView2 "*Dessus", 5
et ça fonctionne maintenant.

Je ne pensait pas que la sélection d'une vue pouvait influer sur une fonction.
jibe
Ewok SolidWorks
 
Messages: 5
Inscription: Lun 17 Mar 2014, 10:12


Retourner vers Questions générales sur les API

 


  • Articles en relation
    Réponses
    Vus
    Dernier message

Qui est en ligne

Utilisateurs parcourant ce forum: Aucun utilisateur enregistré et 4 invités

banniere